#include "verbimorfo.hh"
#include "nominimorfo.hh"

#include <string>
#include <cstdio>
#include <vector>

//#define _GNU_SOURCE                           
#include <getopt.h>

using std::string;
using std::printf;
using std::fprintf;

bool debugflag = false;

int main(int argc, char *const *argv)
{
    bool nega = false;
    string pers = "pas";
    string aika = "preesens";
    string tapa = "ind";
    string sija = "nom";
    string medipre = "";
    bool monikko = false;
    bool passiivi = false;
    int verbose = 0;
    
    bool errors = false;
    bool sanoja = false;
    for(;;)
    {
        static struct option long_options[] =
        {
            {"help",     0,  0,'h'},
            {"version",  0,  0,'V'},
            {"pers",     1,  0,'p'},
            {"nega",     0,  0,'n'},
            {"aika",     1,  0,'t'},
            {"tapa",     1,  0,'m'},
            {"moni",     0,  0,'l'},
            {"pass",     0,  0,'a'},
            {"sija",     1,  0,'j'},
            {"medipre",  1,  0,'M'},
            {"verbose",  0,  0,'v'},
            {"debug",    0,  0,'d'}
        };
        
        switch(getopt_long(argc, argv, "-hVp:n:t:m:lj:M:vd", long_options, NULL))
        {
            case 'V': printf("%s\n", VERSION); return 0;
            case 'p': pers = optarg; break;
            case 'n': nega = true; break;
            case 't': aika = optarg; break;
            case 'm': tapa = optarg; break;
            case 'j': sija = optarg; break;
            case 'M': medipre = optarg; break;
            case 'l': monikko = true; break;
            case 'a': passiivi = true; break;
            case 'v': if(true)++verbose;else --verbose; break;
            case 'd': debugflag = true; break;
            case 'h':
            Help:
                printf(
                    "formodemo v"VERSION" - Copyright (C) 1992,2005 Bisqwit (http://iki.fi/bisqwit/)\n"
                    "Kiitokset Juha Niemiselle avusta.\n"
                    "\n"
                    "Kytt: %s [<option> [<...>]] <sana> [<...>]\n"
                    "\n"
                    "Valitsimet:\n", argv[0]);
                printf(
                    "  --help, -h             Tm ohje\n"
                    "  --version, -V          Tulostaa versiotiedon\n"
                    "  --pers, -p<persoona>   Valitse omistusliite (yks1,yks2,yks3,mon1,mon2,mon3,pass)\n"
                    "  --nega, -n             Valitse negaatio (finiittien verbien taivutukseen)\n"
                    "  --moni, -l             Valitse monikko\n"
                    "  --aika, -t<aika>       Valitse aikamuoto (pr,i,pe,pl finiittien verbien taivutukseen)\n"
                    "  --tapa, -m<tapa>       Valitse tapaluokka (ind,kond,pot,imp,[1-5]i,1p,2p,suor,johto[1-7]) (verbin taivutukseen)\n"
                    "  --sija, -j<sija>       Valitse sijamuoto (nom,gen,ak,es,pa,tr,ine,el,il,ade,abl,al,abe,kom,ins)\n"
                    "  --medipre, -M<koodi>   Mediaalinen esiksittely verbeille (a/p)\n"
                    "  --verbose, -v          Lis tulostettavan tiedon mr.\n"
                    "  --debug, -d            Debug.\n"
                     );
                printf(
                    "\nHuom: Laita taivutettavat sanat komentorivin loppuun.\n"
                    "Uudet valitsimet vaikuttavat vain sit seuraaviin sanoihin.\n");
                return 0;
            case 1:
            {
                string word = optarg;
                
                for(unsigned m=0; m<medipre.size(); ++m)
                {
                    if(medipre[m]=='a')
                        word = Mediaaliksi(word, false);
                    else if(medipre[m]=='p')
                        word = Mediaaliksi(word, true);
                    else
                    {
                        fprintf(stderr, "%s: Unknown medial key: '%c' ('a' and 'p' are known)\n",
                            word.c_str(), medipre[m]);
                    }
                }

                string result;
                
                aikamuoto a;
                sijamuoto j;
                persoona p;
                tapaluokka t;
                
/* The following code has been generated by hashes from hashes.txt */
#include "verb-main-hash.inc"

                if(nega && t != INDIKATIIVI && t != KONDITIONAALI && t != POTENTIAALI && t != IMPERATIIVI)
                {
                    fprintf(stderr, "%s: Negaatio soveltuu vain finiitteihin verbeihin. Negaatio jtetty huomiotta.\n", word.c_str());
                    nega = false;
                }
                if(passiivi && t != PARTISIIPPI1 && t != PARTISIIPPI2 && t != INFINITIIVI2 && t != INFINITIIVI3)
                {
                    fprintf(stderr, "%s: -a (passiivi) -vipu soveltuu vain partisiippeihin ja II ja III infinitiiviin.\n"
                                    "Jos haluat saada muunlaisen verbin passiivimuotoon, valitse passiivinen persoona -ppass -vivulla.\n", word.c_str());
                }
                if(j != NOMINATIIVI && (t == INDIKATIIVI || t == KONDITIONAALI || t == POTENTIAALI || t == IMPERATIIVI))
                {
                    fprintf(stderr, "%s: Finiiteill verbeill ei ole sijamuotoja. Sijamuotomritys jtetty huomiotta.\n", word.c_str());
                    j = NOMINATIIVI;
                }
                sanoja = true;
                
                string sana = word;
                switch(t)
                {
                    case INDIKATIIVI:      word = Indikatiiviksi(word,a,p,!nega); break;
                    case KONDITIONAALI:    word = Konditionaaliksi(word,a,p,!nega); break;
                    case POTENTIAALI:      word = Potentiaaliksi(word,a,p,!nega); break;
                    case IMPERATIIVI:      word = Imperatiiviksi(word,a,p,!nega); break;
                    case PARTISIIPPI1:     word = Partisiipiksi1(word,passiivi); break;
                    case PARTISIIPPI2:     word = Partisiipiksi2(word,passiivi); break;
                    case INFINITIIVI1:     word = Infinitiiviksi1(word); InfiniMuotoTarkistus(1, word, j, monikko, p); break;
                    case INFINITIIVI2:     word = Infinitiiviksi2(word,passiivi); InfiniMuotoTarkistus(2, word, j, monikko, p); break;
                    case INFINITIIVI3:     word = Infinitiiviksi3(word,passiivi); InfiniMuotoTarkistus(3, word, j, monikko, p); break;
                    case INFINITIIVI4:     word = Infinitiiviksi4(word); InfiniMuotoTarkistus(4, word, j, monikko, p); break;
                    case INFINITIIVI5:     word = Infinitiiviksi5(word); InfiniMuotoTarkistus(5, word, j, monikko, p); break;
                    case JOHTO1:           word = JohdaVerbi1(word); break;
                    case JOHTO2:           word = JohdaVerbi2(word); break;
                    case JOHTO3:           word = JohdaVerbi3(word); break;
                    case JOHTO4:           word = JohdaVerbi4(word); break;
                    case JOHTO5:           word = JohdaVerbi5(word); break;
                    case JOHTO6:           word = JohdaVerbi6(word); break;
                    case JOHTO7:           word = JohdaVerbi7(word); break;
                    case SUORITTAJA:       word = Suorittajaksi(word); break;
                }
                switch(t)
                {
                    case INDIKATIIVI:
                    case KONDITIONAALI:
                    case POTENTIAALI:
                    case IMPERATIIVI:
                        // Nit ei voi taivuttaa nomineina
                        break;
                    case INFINITIIVI1:
                    case INFINITIIVI2:
                    case INFINITIIVI3:
                    case INFINITIIVI4:
                    case INFINITIIVI5:
                        // Nille on omat taivutussntns
                        word = InfiniTaivutus(word, j, monikko, p);
                        break;
                    case PARTISIIPPI1:
                    case PARTISIIPPI2:
                    case JOHTO1:
                    case JOHTO2:
                    case JOHTO3:
                    case JOHTO4:
                    case JOHTO5:
                    case JOHTO6:
                    case JOHTO7:
                    case SUORITTAJA:
                        // Nit voi taivuttaa nomineina
                        word = NominiTaivutus(word, j, monikko, p);
                        break;
                }
                
                std::vector<string> defs;
                switch(t)
                {
                    case INDIKATIIVI:      defs.push_back("Indicative"); break;
                    case KONDITIONAALI:    defs.push_back("Conditional"); break;
                    case POTENTIAALI:      defs.push_back("Potential"); break;
                    case IMPERATIIVI:      defs.push_back("Imperative"); break;
                    case PARTISIIPPI1:     defs.push_back("I participle"); break;
                    case PARTISIIPPI2:     defs.push_back("II participle"); break;
                    case INFINITIIVI1:     defs.push_back("I infinitive"); break;
                    case INFINITIIVI2:     defs.push_back("II infinitive"); break;
                    case INFINITIIVI3:     defs.push_back("III infinitive"); break;
                    case INFINITIIVI4:     defs.push_back("IV infinitive"); break;
                    case INFINITIIVI5:     defs.push_back("V infinitive"); break;
                    case JOHTO1:
                    case JOHTO2:
                    case JOHTO3:
                    case JOHTO4:
                    case JOHTO5:
                    case JOHTO6:
                    case JOHTO7:           defs.push_back("Derived form"); break;
                    case SUORITTAJA:       defs.push_back("Actor"); break;
                }

                if(nega)
                    defs.push_back("Negative");

                if(passiivi)
                    defs.push_back("Passive");

                if(t == INDIKATIIVI
                || t == KONDITIONAALI
                || t == POTENTIAALI
                || t == IMPERATIIVI)
                {
                    switch(a)
                    {
                        case PREESENS:         defs.push_back("Present"); break;
                        case IMPERFEKTI:       defs.push_back("Imperfect"); break;
                        case PERFEKTI:         defs.push_back("Perfect"); break;
                        case PLUSKVAMPERFEKTI: defs.push_back("Past perfect"); break;
                    }
                }

                if(t != INDIKATIIVI
                && t != KONDITIONAALI
                && t != POTENTIAALI
                && t != IMPERATIIVI)
                {
                    switch(j)
                    {
                        case NOMINATIIVI:      defs.push_back("Nominative"); break;
                        case GENETIIVI:        defs.push_back("Genetive"); break;
                        case AKKUSATIIVI:      defs.push_back("Accusative"); break;
                        case ESSIIVI:          defs.push_back("Essive"); break;
                        case PARTITIIVI:       defs.push_back("Partitive"); break;
                        case TRANSLATIIVI:     defs.push_back("Translative"); break;
                        case INESSIIVI:        defs.push_back("Inessive"); break;
                        case ELATIIVI:         defs.push_back("Elative"); break;
                        case ILLATIIVI:        defs.push_back("Illative"); break;
                        case ADESSIIVI:        defs.push_back("Adessive"); break;
                        case ABLATIIVI:        defs.push_back("Ablative"); break;
                        case ALLATIIVI:        defs.push_back("Allative"); break;
                        case ABESSIIVI:        defs.push_back("Abessive"); break;
                        case KOMITATIIVI:      defs.push_back("Comitative"); break;
                        case INSTRUKTIIVI:     defs.push_back("Instructive"); break;
                        case SUPERESSIIVI:     defs.push_back("Superessive"); break;
                        case DELATIIVI:        defs.push_back("Delative"); break;
                        case SUBLATIIVI:       defs.push_back("Sublative"); break;
                        case LATIIVI:          defs.push_back("Lative"); break;
                        case TEMPORAALI:       defs.push_back("Temporal"); break;
                        case KAUSATIIVI:       defs.push_back("Causative"); break;
                        case MULTIPLIKATIIVI:  defs.push_back("Multiplicative"); break;
                        case DISTRIBUTIIVI:    defs.push_back("Distributive"); break;
                        case TEMPDISTRIBUTIIVI:defs.push_back("Temporal distributive"); break;
                        case PROLATIIVI:       defs.push_back("Prolative"); break;
                        case SITUATIIVI:       defs.push_back("Situative"); break;
                        case OPPOSITIIVI:      defs.push_back("Oppositive"); break;
                    }
                }

                if(monikko)
                    defs.push_back("Plural");

                if(j != INSTRUKTIIVI && (t != INFINITIIVI1 || j != NOMINATIIVI))
                {
                    if(t == INDIKATIIVI
                    || t == KONDITIONAALI
                    || t == POTENTIAALI
                    || t == IMPERATIIVI)
                    {
                        switch(p)
                        {
                            case YKS1: defs.push_back("Singular 1st person"); break;
                            case YKS2: defs.push_back("Singular 2nd person"); break;
                            case YKS3: defs.push_back("Singular 3rd person"); break;
                            case MON1: defs.push_back("Plural 1st person"); break;
                            case MON2: defs.push_back("Plural 2nd person"); break;
                            case MON3: defs.push_back("Plural 3rd person"); break;
                            case PASSIIVI: defs.push_back("Anonymous person (passive)"); break;
                        }
                    }
                    else
                    {
                        switch(p)
                        {
                            case YKS1: defs.push_back("Singular 1st"); break;
                            case YKS2: defs.push_back("Singular 2nd"); break;
                            case YKS3: defs.push_back("Singular 3rd"); break;
                            case MON1: defs.push_back("Plural 1st"); break;
                            case MON2: defs.push_back("Plural 2nd"); break;
                            case MON3: defs.push_back("Plural 3rd"); break;
                            case PASSIIVI: /*ei omistusliitett*/ break;
                        }
                    }
                }
                for(unsigned a=0; a<defs.size(); ++a)
                    printf("> %s ", defs[a].c_str());
                printf("\n");
                printf("%s\n", word.c_str());
                break;
            }
            case -1: goto done_args;
            default:
                errors=true;
        }
    }
done_args:
    if(!errors && !sanoja)
    {
        fprintf(stderr, "Sanaton!\n");
        goto Help;
    }
    return 0;
}
